package com.ruoyi.system.service.webService;

import java.time.LocalDateTime;
import java.util.List;

import cn.ljserver.tool.weboffice.v3.exception.FileNotExist;
import com.ruoyi.common.config.RuoYiConfig;
import com.ruoyi.common.core.domain.entity.SysUser;
import com.ruoyi.common.core.redis.RedisCache;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.common.utils.file.FileUploadUtils;
import com.ruoyi.system.domain.loan.LoanApplicationFj;
import com.ruoyi.system.domain.webOffice.WebofficeFj;
import com.ruoyi.system.mapper.WebofficeFjMapper;
import lombok.SneakyThrows;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.mock.web.MockMultipartFile;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

/**
 * webOffice附件记录Service业务层处理
 * 
 * @author boman
 * @date 2024-05-20
 */
@Service
public class WebofficeFjServiceImpl implements IWebofficeFjService 
{
    @Autowired
    private WebofficeFjMapper webofficeFjMapper;

    @Autowired
    private RedisCache redisCache;

    /**
     * 查询webOffice附件记录
     * 
     * @param webofficeId webOffice附件记录主键
     * @return webOffice附件记录
     */
    @Override
    public WebofficeFj selectWebofficeFjByWebofficeId(Long webofficeId)
    {
        return webofficeFjMapper.selectWebofficeFjByWebofficeId(webofficeId);
    }

    /**
     * 查询webOffice附件记录列表
     * 
     * @param webofficeFj webOffice附件记录
     * @return webOffice附件记录
     */
    @Override
    public List<WebofficeFj> selectWebofficeFjList(WebofficeFj webofficeFj)
    {
        return webofficeFjMapper.selectWebofficeFjList(webofficeFj);
    }

    /**
     * 新增webOffice附件记录
     * 
     * @param webofficeFj webOffice附件记录
     * @return 结果
     */
    @Override
    public int insertWebofficeFj(WebofficeFj webofficeFj)
    {
        webofficeFj.setCreateTime(LocalDateTime.now());
        return webofficeFjMapper.insertWebofficeFj(webofficeFj);
    }

    /**
     * 修改webOffice附件记录
     * 
     * @param webofficeFj webOffice附件记录
     * @return 结果
     */
    @Override
    public int updateWebofficeFj(WebofficeFj webofficeFj)
    {
        webofficeFj.setUpdateTime(LocalDateTime.now());
        return webofficeFjMapper.updateWebofficeFj(webofficeFj);
    }

    /**
     * 批量删除webOffice附件记录
     * 
     * @param webofficeIds 需要删除的webOffice附件记录主键
     * @return 结果
     */
    @Override
    public int deleteWebofficeFjByWebofficeIds(Long[] webofficeIds)
    {
        return webofficeFjMapper.deleteWebofficeFjByWebofficeIds(webofficeIds);
    }

    /**
     * 删除webOffice附件记录信息
     * 
     * @param webofficeId webOffice附件记录主键
     * @return 结果
     */
    @Override
    public int deleteWebofficeFjByWebofficeId(Long webofficeId)
    {
        return webofficeFjMapper.deleteWebofficeFjByWebofficeId(webofficeId);
    }

    @Override
    public String upload(MultipartFile file) {
        return null;
    }

    @SneakyThrows
    @Override
    public String upload(String fileId, byte[] content, String suffix) {

        SysUser user = SecurityUtils.getLoginUser().getUser();
        //从redis取文件信息
        LoanApplicationFj cacheObject = redisCache.getCacheObject(fileId + "info");
        if (cacheObject == null) {
            throw new FileNotExist();
        }

        MultipartFile file = new MockMultipartFile(cacheObject.getName(), cacheObject.getName(), suffix, content);
        // 上传文件路径
        String filePath = RuoYiConfig.getUploadPath();
        // 上传并返回新文件名称
        String fileName = FileUploadUtils.uploadLoanApplicationNumber(filePath, file, cacheObject.getLoanApplicationNumber(), file.getOriginalFilename());
        //String url = serverConfig.getUrl() + fileName;
        //将文件存入在线编辑预存表
        WebofficeFj webofficeFj = fetchFile(fileId);
        webofficeFj.setWebofficeId(0l);
        webofficeFj.setVersion(webofficeFj.getVersion() + 1);
        webofficeFj.setCreateTime(LocalDateTime.now());
        webofficeFj.setUpdateTime(LocalDateTime.now());
        webofficeFj.setSize(Long.valueOf(file.getSize()));
        webofficeFj.setName(file.getName());
        webofficeFj.setCreateBy(user.getNickName());
        webofficeFjMapper.insertWebofficeFj(webofficeFj);
        return fileName;
    }

    public List<WebofficeFj> selectWebofficeFjList(String fileId)
    {
        if(!DateUtils.isNumeric(fileId)){
            fileId = "0";
        }
        WebofficeFj webofficeFj = new WebofficeFj();
        webofficeFj.setFjId(Long.valueOf(fileId));
        return webofficeFjMapper.selectWebofficeFjList(webofficeFj);
    }

    /***
     * 获取单个版本详情
     * @param fileId
     * @return
     */
    public WebofficeFj fetchFileVersion(String fileId, int version)
    {
        if(!DateUtils.isNumeric(fileId)){
            fileId = "0";
        }
        WebofficeFj webofficeFj = new WebofficeFj();
        webofficeFj.setFjId(Long.valueOf(fileId));
        webofficeFj.setVersion(version);
        List<WebofficeFj> webofficeFjs = webofficeFjMapper.selectWebofficeFjList(webofficeFj);
        if(webofficeFjs!=null && webofficeFjs.size()>0){
            return webofficeFjs.get(0);
        }else {
            return new WebofficeFj();
        }

    }

    /***
     * 查询最新版本的文件
     * @param fileId
     * @return
     */
    public WebofficeFj fetchFile(String fileId)
    {
        if(!DateUtils.isNumeric(fileId)){
            fileId = "0";
        }
        WebofficeFj webofficeFj = new WebofficeFj();
        webofficeFj.setFjId(Long.valueOf(fileId));
        List<WebofficeFj> webofficeFjs = webofficeFjMapper.selectWebofficeFjList(webofficeFj);
        if(webofficeFjs!=null && webofficeFjs.size()>0){
            return webofficeFjs.get(0);
        }else {
            return new WebofficeFj();
        }
    }
}
